// Algorithme de couplage max (Nicolas pour le probleme des slides).
// Apparie des slides a des numeros.
// Tout initialiser correctement pour le faire tourner hors contexte.

#include <iostream>
#include <cstdlib>
#include <cstdio>

int n;
int adj[50][50]; // adjacence
int slide_traite[50]; // 1 si le slide est trait

int file_slides[100]; // file des slides pour l'algorithme de couplage
int tete, bout; // tete et queue de la file 
int num_mate_of_sli[50]; // liste des coupls dans un couplage max
int sli_mate_of_num[50]; // liste des coupls dans un couplage max
int num_libre[50]; // numro libre, voisin du slide dans l'algorithme de couplage max
int sli_prev[50]; // slide prcdent dans le chemin

void initialisation() {
    int i,j;
    
    for(i = 0; i < n; i++)
        num_libre[i] = -1;
    for(i = 0; i < n; i++)
        for(j = 0; j < n; j++)
            if (adj[i][j] && sli_mate_of_num[j] < 0) 
                num_libre[i] = j;
}

void augmente_chemin(int i) {
    if (sli_prev[i] < 0) {
        num_mate_of_sli[i] = num_libre[i];
        sli_mate_of_num[num_libre[i]] = i;
    } else {
        num_libre[sli_prev[i]] = num_mate_of_sli[i];
        num_mate_of_sli[i] = num_libre[i];
        sli_mate_of_num[num_libre[i]] = i;
        augmente_chemin(sli_prev[i]);
    }
}

void
couplage_biparti() {
    int i, j, k, fini, trouve;
    for(i = 0; i < n; i++) {
        num_mate_of_sli[i] = -1;
        sli_mate_of_num[i] = -1;
    }
    fini = 0;
    while (!fini) {
        initialisation();
        tete = bout = 0;
        for(i = 0; i < n; i++) { // met les sommets non matchs dans la file
            if (!slide_traite[i] && num_mate_of_sli[i] < 0) {
                file_slides[bout] = i;
                bout++;
            }
            sli_prev[i] = -1;
        }
        trouve = 0;
        while (!trouve && tete < bout) {
            i = file_slides[tete];
            tete++;
            if (num_libre[i] >= 0) { // un chemin amlioration a t trouv
                augmente_chemin(i);
                trouve = 1;
            } else { // tend les chemins amliorants depuis i
                for(j = 0; j < n; j++) {
                    if (adj[i][j] && sli_mate_of_num[j] >= 0 && sli_mate_of_num[j] != i) {
                        k = sli_mate_of_num[j];
                        if (sli_prev[k] < 0) { // k n'est pas dans la file
                            sli_prev[k] = i;
                            file_slides[bout] = k;
                            bout++;
                        }
                    }
                }
            }
        }
        if (tete >= bout) {
            fini = 1;
        }
    }
}

int test_couple(int ce_i) {
    int i,j, k, trouve;
    int ce_j = num_mate_of_sli[ce_i];
    
    num_mate_of_sli[ce_i] = -1;
    sli_mate_of_num[ce_j] = -1;
    adj[ce_i][ce_j] = 0;

    initialisation();
    tete = bout = 0;
    file_slides[bout] = ce_i;
    bout++;
    for(i = 0; i < n; i++) {
        sli_prev[i] = -1;
    }
    trouve = 0;
    while (!trouve && tete < bout) {
        i = file_slides[tete];
        tete++;
        if (num_libre[i] >= 0) { // un chemin amlioration a t trouv -- on n'augmente pas le graphe
            trouve = 1;
        } else { // tend les chemins amliorants depuis i
            for(j = 0; j < n; j++) {
                if (adj[i][j] && sli_mate_of_num[j] >= 0 && sli_mate_of_num[j] != i) {
                    k = sli_mate_of_num[j];
                    if (sli_prev[k] < 0) { // k n'est pas dans la file
                        sli_prev[k] = i;
                        file_slides[bout] = k;
                        bout++;
                    }
                }
            }
        }
    }

    // rtablit le graphe
    num_mate_of_sli[ce_i] = ce_j;
    sli_mate_of_num[ce_j] = ce_i;
    adj[ce_i][ce_j] = 1;
    
    return !trouve; // 1 si l'arete ce_i,ce_j appartient  tous les couplages
}

void print_couplage() {
    int i;
    std::cout << "couplage = ";
    for(i = 0; i < n; i++)
        std::cout << "[" << (char)(i+65) << "," << num_mate_of_sli[i]+1 << "] ";
    std::cout << "\n";
}


int main()
{
}
